package com.example.kpprinter;

import android.app.Activity;
import android.widget.Toast;

import com.example.kpprinter.java.AndroidPrintSdk;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** KpprinterPlugin */
public class KpprinterPlugin implements MethodCallHandler , EventChannel.StreamHandler{
  private Activity mActivity;


  public KpprinterPlugin(Activity activity) {
    mActivity = activity;
    AndroidPrintSdk.getInstance(mActivity).initPrint();

//    AndroidPrintSdk.getInstance(mActivity).setOnBlueToothEnableListener(new AndroidPrintSdk.BlueToothEnableListener() {
//      @Override
//      public void enableFalse() {
//        Toast.makeText(mActivity, "嘿man，你蓝牙没打开", Toast.LENGTH_SHORT).show();
//      }
//    });
//
//
//    AndroidPrintSdk.getInstance(mActivity).setOnDeviceConnectListener(new AndroidPrintSdk.DeviceConnectListener() {
//      @Override
//      public void connectFalse() {
//
//      }
//
//      @Override
//      public void connectSuccess() {
//
//      }
//
//      @Override
//      public void connectUnConnect() {
//        Toast.makeText(mActivity, "嘿man，你打印机还没连接呢", Toast.LENGTH_SHORT).show();
//      }
//    });

  }

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    KpprinterPlugin instance = new KpprinterPlugin(registrar.activity());
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "kpprinter");
    channel.setMethodCallHandler(instance);


    EventChannel printResult = new EventChannel(registrar.messenger(), "ltd_search_result");
    printResult.setStreamHandler(instance);

  }

  @Override
  public void onMethodCall(MethodCall call, final Result result) {
    switch (call.method) {
      case "printer_search":
        AndroidPrintSdk.getInstance(mActivity).searchPrint();
        AndroidPrintSdk.getInstance(mActivity).setOnDeviceSearchListener(new AndroidPrintSdk.DeviceSearchListener() {
          @Override
          public void searching() {
            Toast.makeText(mActivity, "Flutter开始搜索", Toast.LENGTH_SHORT).show();
          }

          @Override
          public void searchFinish() {
            Toast.makeText(mActivity, "Flutter搜索完成", Toast.LENGTH_LONG).show();
          }
        });
        break;

      case "printer_connectAPrinter":
//        AndroidPrintSdk.getInstance(mActivity).connectPrint((Map<String, String>) call.arguments);
//
//        AndroidPrintSdk.getInstance(mActivity).setOnDeviceConnectListener(new AndroidPrintSdk.DeviceConnectListener() {
//          @Override
//          public void connectFalse() {
//            mActivity.runOnUiThread(new Runnable() {
//              @Override
//              public void run() {
//                result.success("false");
//                Toast.makeText(mActivity, "Flutter连接打印机失败", Toast.LENGTH_SHORT).show();
//              }
//            });
//          }
//
//          @Override
//          public void connectSuccess() {
//            mActivity.runOnUiThread(new Runnable() {
//              @Override
//              public void run() {
//                result.success("true");
//                Toast.makeText(mActivity, "Flutter连接打印机成功", Toast.LENGTH_SHORT).show();
//              }
//            });
//          }
//
//          @Override
//          public void connectUnConnect() {
//            result.success("false");
//            Toast.makeText(mActivity, "Flutter还没连接打印机", Toast.LENGTH_SHORT).show();
//          }
//        });

        break;
      case "printer_connectAndPrint":
        AndroidPrintSdk.getInstance(mActivity).connectAndPrint((Map<String, Object>) call.arguments);

        AndroidPrintSdk.getInstance(mActivity).setOnPrintResultListener(new AndroidPrintSdk.PrintResultListener() {
          @Override
          public void printSuccess() {
            mActivity.runOnUiThread(new Runnable() {
              @Override
              public void run() {
                Toast.makeText(mActivity, "Flutter打印成功", Toast.LENGTH_LONG).show();
              }
            });
          }

          @Override
          public void printFail() {
            mActivity.runOnUiThread(new Runnable() {
              @Override
              public void run() {
                Toast.makeText(mActivity, "Flutter打印失败", Toast.LENGTH_LONG).show();
              }
            });
          }
        });

        break;
      case "printer_disconnectAPrinter":
//        AndroidPrintSdk.getInstance(mActivity).disPrinter(false);
//
//        AndroidPrintSdk.getInstance(mActivity).setOnDeviceConnectListener(new AndroidPrintSdk.DeviceConnectListener() {
//          @Override
//          public void connectFalse() {
//            mActivity.runOnUiThread(new Runnable() {
//              @Override
//              public void run() {
//                result.success("true");
//                Toast.makeText(mActivity, "Flutter连接打印机失败", Toast.LENGTH_SHORT).show();
//              }
//            });
//          }
//
//          @Override
//          public void connectSuccess() {
//            mActivity.runOnUiThread(new Runnable() {
//              @Override
//              public void run() {
//                result.success("false");
//                Toast.makeText(mActivity, "Flutter连接打印机成功", Toast.LENGTH_SHORT).show();
//              }
//            });
//          }
//
//          @Override
//          public void connectUnConnect() {
//            result.success("true");
//            Toast.makeText(mActivity, "Flutter打印机还没连接", Toast.LENGTH_SHORT).show();
//
//          }
//        });

        break;
      default:
        result.notImplemented();
        break;
    }
  }

  @Override
  public void onListen(Object o, final EventChannel.EventSink eventSink) {
    AndroidPrintSdk.getInstance(mActivity).setPrintDeviceMsgListener(new AndroidPrintSdk.PrintDeviceMsgListener() {
      @Override
      public void printerMsg(LinkedHashMap<String, String> map) {
        if (map.size() > 0)
          eventSink.success(map);
        else
          eventSink.error("无数据", "无数据呀", null);
//            Log.e("flutter<==>Address",map.get("printName")+"=="+map.get("printerAddress"));
      }
    });
  }

  @Override
  public void onCancel(Object o) {

  }
}
